%%
%%  execute man then remove backspaces
%%

%!% remove _^H and ^H combinations and multiple blank lines (man page)
define clean_manpage ()
{
   variable clean = "Cleaning man page...";

   push_spot ();
   bob ();

   flush (clean);
   replace ("_\010", Null_String);	% remove _^H underscores
   while ( fsearch ("\010") )
     {
	del ();
	del ();
     }				% remove overstrike
   trim_buffer ();		% remove multiple blank lines
   pop_spot ();

   flush (strcat (clean, "done"));
}

%!% retrieve a man page entry and use clean_manpage to clean it up
define unix_man ()
{
   variable subj, buf = "*manual-entry*", msg = "Getting man page...";

   subj = read_mini ("man", Null_String, Null_String);
   !if ( strlen (subj) ) return;

   pop2buf (buf);
   set_readonly (0);
   erase_buffer ();
   flush (msg);
#ifdef OS2
   () = run_shell_cmd (Sprintf ("man %s 2> nul", subj, 1));
#else
   () = run_shell_cmd (Sprintf ("man %s 2> /dev/null", subj, 1));
#endif
   clean_manpage ();
   bob ();
   set_buffer_modified_flag (0);
   most_mode ();
   set_readonly (1);
}

#ifdef 0
. ( [clean buf cmd subj ctrl_h] "*manual-entry*" =buf
.   "Cleaning man page..." =clean
  
.   "man" Null_String Null_String read_mini =subj
.   subj strlen {return} !if
  
#ifdef OS2
.   "man " subj strcat " 2> nul" strcat =cmd
#else
.   "man " subj strcat " 2> /dev/null" strcat =cmd
#endif
.   buf pop2buf
.   0 set_readonly
.   erase_buffer
.   "Getting man page..." flush
.   cmd run_shell_cmd pop
.   clean flush
.   8 char =ctrl_h
.   bob "_" ctrl_h strcat Null_String replace     %% remove _^H combinations
.   bob  {ctrl_h fsearch} {del del} while  %% remove remaining overstrikes
  %%
  %%  remove multiple blank lines--- should make this standalone
  %%
.   bob {eolp eobp not and}{del} while
.   {down_1} {
.     eol bolp 
.       { down_1 {break} !if
.         {{eol bolp}{eobp not} andelse} {del} while
.       } if
.   } while
.   bob
  %%
  %%  set buffer no modified
  %%
.   getbuf_info pop 0 setbuf_info
.   clean "done" strcat flush
.   most_mode
.   1 set_readonly
. ) unix_man
#endif
